<?php
/*
Plugin Name: External ImageMagick
Version: auto
Description: Use external ImageMagick installation
Plugin URI: auto
Author: P@t
Author URI: http://www.gauchon.com
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('IMAGICK_EXEC_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

add_event_handler('get_admin_plugin_menu_links', 'imagick_exec_init');
add_event_handler('ws_add_methods', 'ws_add_method_load_imagick_exec_functions');

function imagick_exec_init($menu)
{
  global $conf, $page;

  if (in_array($page['page'], array('intro','plugins_list','photos_add')) and !test_imagick_exec())
  {
    array_push($page['warnings'], l10n('Unable to locate ImageMagick directory. Please fill $conf[\'imagick_directory\'] in your local configuration file.'));
  }
  elseif (($page['page'] == 'photos_add' or script_basename() == 'uploadify') and test_imagick_exec())
  {
    include_once(IMAGICK_EXEC_PATH.'functions.inc.php');
    include_once(IMAGICK_EXEC_PATH.'imagick.class.php');
  }

  return $menu;
}

function ws_add_method_load_imagick_exec_functions()
{
  if (test_imagick_exec())
  {
    include_once(IMAGICK_EXEC_PATH.'functions.inc.php');
    include_once(IMAGICK_EXEC_PATH.'imagick.class.php');
  }
}

function test_imagick_exec()
{
  global $conf;

  $imagick_dir = isset($conf['imagick_dir']) ? rtrim($conf['imagick_dir'], ' /\\').'/' : '';
  @exec($imagick_dir.'convert', $returnarray, $returnvalue);
  return (!$returnvalue and !empty($returnarray[0]) and preg_match('/ImageMagick/', $returnarray[0]));
}

?>